package org.processmining.humbertogarciacaballero.models.gui;

import prefuse.Display;

public abstract class GraphView {

	// The visualization
	protected GraphVisualization vis;
	
	// The Display
	protected Display d;
	
	protected int margin;
	
	protected long duration;
	
	public GraphView(GraphVisualization vis) {
		this(vis, 10);
	}
	
	public GraphView(GraphVisualization vis, int margin) {
		this(vis, margin, 2000);
	}
	
	public GraphView(GraphVisualization vis, int margin, long duration) {
		this.vis = vis;
		this.margin = margin;
		this.duration = duration;
		
		d = new Display(vis.getVisualization());
		setUpDisplay();
	}

	protected abstract void setUpDisplay();
	
	public Display getDisplay() {
		return d;
	}
}
