package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.gui.components.PlaceConformanceInformationPopUp;
import org.processmining.humbertogarciacaballero.models.model.NodeType;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsViz;

import prefuse.Display;
import prefuse.Visualization;
import prefuse.controls.ControlAdapter;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class PlaceHoverInformationControl extends ControlAdapter {

	private PNetVisualizerController controller;
	private PlaceConformanceInformationPopUp placePopup;
	private final Point2D point = new Point2D.Double();

	public PlaceHoverInformationControl(Display d) {
		placePopup = new PlaceConformanceInformationPopUp();
		placePopup.setVisible(false);
		d.add(placePopup, 1);
		controller = PNetVisualizerController.getInstance();
	}

	@Override
	public void itemEntered(VisualItem item, MouseEvent e) {
		if (item instanceof NodeItem && NodeType.valueOf(item.getString(PNConstants.NODE_TYPE_KEY)) == NodeType.PLACE) {
			if (ProcessAnalyticsViz.selectedActivity == null || (ProcessAnalyticsViz.selectedActivity != null && item.getBoolean("placeLogMove"))) {
				item.setHighlighted(true);
				placePopup.populatePopUp((NodeItem) item);
				runAnimations(item);

				point.setLocation(item.getBounds().getMaxX(), item.getBounds().getMaxY());
				((Display) e.getSource()).getTransform().transform(point, point);
				int x = (int) point.getX(), y = (int) point.getY();
				placePopup.setLocation(x, y);
				placePopup.setVisible(true);
				((Display) e.getSource()).repaint();
				controller.setTooltipControlEnabled(false);
			}
		}
	}

	@Override
	public void itemExited(VisualItem item, MouseEvent e) {
		if (item == placePopup.getPlace()) {
			item.setHighlighted(false);
			runAnimations(item);
			placePopup.setVisible(false);
			placePopup.clear();
			controller.setTooltipControlEnabled(true);
		}
	}

	private void runAnimations(VisualItem item) {
		Visualization vis = item.getVisualization();
		vis.cancel(PNConstants.VIS_HIGHLIGHT_ACTIONS_NAME);
		vis.run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
		vis.run(PNConstants.VIS_HIGHLIGHT_ACTIONS_NAME);
	}
}
