package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.event.MouseEvent;

import javax.swing.SwingUtilities;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.humbertogarciacaballero.models.gui.GraphVisualization;
import org.processmining.humbertogarciacaballero.models.model.NodeType;
import org.processmining.humbertogarciacaballero.models.model.PNConstants;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsViz;

import prefuse.Display;
import prefuse.Visualization;
import prefuse.controls.ControlAdapter;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;

public class SelectSpecificTransitionControl extends ControlAdapter {

	private VisualItem selectedItem;

	public SelectSpecificTransitionControl() {
		super();
	}

	@Override
	public void itemClicked(VisualItem item, MouseEvent e) {
		if (!SwingUtilities.isRightMouseButton(e) || !(item instanceof NodeItem && NodeType.valueOf(item.getString(PNConstants.NODE_TYPE_KEY)) == NodeType.TRANSITION))
			return;

		Display d = (Display) e.getComponent();
		Visualization vis = d.getVisualization();
		if (selectedItem != null) {
			selectedItem.setBoolean(PNConstants.NODE_SELECTED_TRANSITION, false);

			if (selectedItem == item) {
				selectedItem = null;
				PNetVisualizerController.getInstance().getProcessAnalytics().setSelectedTran(null);
				vis.run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
				d.repaint();
				return;
			}
		}
		
		item.setBoolean(PNConstants.NODE_SELECTED_TRANSITION, true);
		PNetVisualizerController.getInstance().getProcessAnalytics().setSelectedTran((Transition) ProcessAnalyticsViz.findNode((NodeItem)item));
		selectedItem = item;
		vis.getGroup(GraphVisualization.SELECTED_NODES).removeTuple(item);

		vis.run(PNConstants.VIS_FILL_NODES_ACTIONS_NAME);
		d.repaint();
	}
}
