package org.processmining.humbertogarciacaballero.models.model.commands;

import org.processmining.humbertogarciacaballero.models.gui.GraphVisualization;
import org.processmining.humbertogarciacaballero.models.model.layout.HierarchicalLayouter;

public class RotateClockwiseCommand extends AbstractCommand {

    private GraphVisualization vis;
    private HierarchicalLayouter layouter;
    
    public RotateClockwiseCommand(GraphVisualization vis, HierarchicalLayouter layouter) {
        this.vis = vis;
        this.layouter = layouter;
    }
    
    @Override
    public void doIt() {
        vis.rotateClockwise();
        layouter.setLayoutOrientation(layouter.getLayoutOrientation().clockwise());
        finish();
    }

    @Override
    public void undoIt() {
        vis.rotateAnticlockwise();
        layouter.setLayoutOrientation(layouter.getLayoutOrientation().antiClockwise());
        finish();
    }

}
