package org.processmining.humbertogarciacaballero.models.model.layout.data;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import prefuse.data.Node;

public class Layer {

	private int position;
	private List<Node> nodes;
	
	public Layer(int position) {
		this.nodes = new LinkedList<>();
		this.position = position;
	}
	
	public Layer(Layer layer) {
		this(layer.position);
		this.nodes.addAll(layer.nodes);
	}

	public void addNode(Node n) {
		nodes.add(n);
	}
	
	public int getPosition() {
		return position;
	}
	
	public List<Node> getNodes() {
		return nodes;
	}
	
	public int getSize() {
		return nodes.size();
	}
	
	public String toString() {
		return "[" +
				"position:" + position +
				",nodes:" + Arrays.toString(nodes.toArray()) + "]";
	}

	public void clear() {
		nodes.clear();
	}

	public void remove(Node n) {
		nodes.remove(n);
	}
}
