package org.processmining.humbertogarciacaballero.models.model.layout.data;

import org.processmining.humbertogarciacaballero.models.gui.render.PolylineEdgeRenderer;
import org.processmining.humbertogarciacaballero.models.gui.render.StraightLineEdgeRenderer;
import org.processmining.humbertogarciacaballero.models.model.layout.stage.lines.BendCalculator;
import org.processmining.humbertogarciacaballero.models.model.layout.stage.lines.PolylineBendCalculator;
import org.processmining.humbertogarciacaballero.models.model.layout.stage.lines.StraightLineBendCalculator;

import prefuse.render.EdgeRenderer;

public enum LineType {

	POLYLINE("Polyline", new PolylineEdgeRenderer(), PolylineBendCalculator.class), STRAIGHT("Straight line", new StraightLineEdgeRenderer(), StraightLineBendCalculator.class);
	
	private final String label;
	private final EdgeRenderer renderer;
	private final Class<? extends BendCalculator> bendCalculator;
	
	private LineType(String label, EdgeRenderer renderer, Class<? extends BendCalculator> bendCalculator) {
		this.label = label;
		this.renderer = renderer;
		this.bendCalculator = bendCalculator;
	}
	
	public EdgeRenderer getRenderer() {
		return renderer;
	}

	public Class<? extends BendCalculator> getBendCalculator() {
		return bendCalculator;
	}

	public String toString() {
		return label;
	}
}
