package org.processmining.humbertogarciacaballero.models.model.layout.stage.lines;

import java.awt.geom.Point2D;
import java.util.List;

import org.processmining.humbertogarciacaballero.models.model.layout.HierarchicalLayouter;
import org.processmining.humbertogarciacaballero.models.model.layout.HierarchicalLayouter.NodeParams;
import org.processmining.humbertogarciacaballero.models.model.layout.data.LayoutOrientation;
import org.processmining.humbertogarciacaballero.models.model.layout.stage.HierarchicalLayoutContext;

import prefuse.data.Edge;
import prefuse.data.Node;

public abstract class BendCalculator {

	private HierarchicalLayoutContext context;
	
	public BendCalculator(HierarchicalLayoutContext context) {
		this.context = context;
	}
	
	public abstract void createBends(Edge e, int layerDifference, List<Node> dummies);

	protected Point2D calculatePort(float offset, float x, float y, LayoutOrientation orientation) {
		Point2D point = new Point2D.Float();
		
		switch (orientation) {
		case TOP_TO_BOTTOM:
		case BOTTOM_TO_TOP:
			point.setLocation(x - offset, y);
			break;
		case LEFT_TO_RIGHT:
		case RIGHT_TO_LEFT:
			point.setLocation(x, y + offset);
			break;
		}
		
		return point;
	}
	
	protected float getX(Node n) {
		return ((NodeParams)n.get(HierarchicalLayouter.NODE_PARAMS)).x;
	}

	protected float getY(Node n) {
		return ((NodeParams)n.get(HierarchicalLayouter.NODE_PARAMS)).y;
	}
	
	public HierarchicalLayoutContext getContext() {
		return context;
	}
}
