package org.processmining.prabhakardixit.featureSelection;

import java.util.ArrayList;

import weka.attributeSelection.AttributeSelection;
import weka.attributeSelection.CfsSubsetEval;
import weka.attributeSelection.GainRatioAttributeEval;
import weka.attributeSelection.InfoGainAttributeEval;
import weka.attributeSelection.OneRAttributeEval;
import weka.attributeSelection.Ranker;
import weka.attributeSelection.ReliefFAttributeEval;
import weka.core.Attribute;
import weka.core.Instances;

public class FilterEvaluatorFunctions {
	protected static AttributeSelection filterEvaluator(Instances trainingData, ArrayList<Attribute> attInfo,
			Evaluators eval) throws Exception {
		AttributeSelection selector = new AttributeSelection();

		Ranker ranker = new Ranker();
		//		ranker.setNumToSelect(Math.min(-1));
		trainingData.setClassIndex(trainingData.numAttributes() - 1);
//		Discretize m_disc = new Discretize();

//		String options = getOptions(attInfo);

//		Instances data = SelectFeaturesUtils.getNumeriNominalInstances(trainingData, options);

		//		NumericToNominal m_disc2 = new NumericToNominal();
		//		m_disc2.setInputFormat(trainingData);
		//		m_disc.setInputFormat(trainingData);
		//		Instances temp = Filter.useFilter(trainingData, m_disc2);

		selector.setSearch(ranker);
		//add evaluator
		switch (eval) {
		//			case CHISQUARED :
		//				ChiSquaredAttributeEval evaluator = new ChiSquaredAttributeEval();
		//				selector.setEvaluator(evaluator);
		//				break;
			case GAINRATIO :
				GainRatioAttributeEval evaluator2 = new GainRatioAttributeEval();
				selector.setEvaluator(evaluator2);
				break;
			case INFOGAIN :
				InfoGainAttributeEval evaluator3 = new InfoGainAttributeEval();
				selector.setEvaluator(evaluator3);
				break;
			case RELIEF :
				ReliefFAttributeEval evaluator4 = new ReliefFAttributeEval();
				selector.setEvaluator(evaluator4);
				break;
			//			case SVM :
			//				SVMAttributeEval evaluator5 = new SVMAttributeEval();
			//				selector.setEvaluator(evaluator5);
			//				break;
			case ONER :
				OneRAttributeEval evaluator6 = new OneRAttributeEval();
				selector.setEvaluator(evaluator6);
				break;
			case CORRELATION :
				CfsSubsetEval evaluator7 = new CfsSubsetEval();
				selector.setEvaluator(evaluator7);
				break;
			default :
				break;

		}

		selector.SelectAttributes(trainingData);

		System.out.println(trainingData);
		SelectFeaturesUtils.printMatrix(selector.rankedAttributes(), attInfo);
		return selector;
	}

	private static String getOptions(ArrayList<Attribute> attInfo) {
		String options = "";
		for (Attribute att : attInfo)
			if (att.name().contains("was_on_ventilation")) {
				//increment by 1 to change from index to range val as needed by setOptions func
				options = options.equals("") ? String.valueOf(attInfo.indexOf(att) + 1) : options + ","
						+ String.valueOf(attInfo.indexOf(att) + 1);
			}
		return options;
	}
}
