package org.processmining.prabhakardixit.featureSelection;

import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.Map;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.util.TableOrder;

public class SwingGraphs {
	// multi output display starts

	public static void updateData(JPanel panel, Map<String, Map<String, Map<String, Double>>> attrMapPerOutput,
			int numOutputs, Map<String, String> outputNameMap) {
		JScrollPane scrp = new JScrollPane(multiOutputPanel(attrMapPerOutput, numOutputs, outputNameMap));
		panel.removeAll();
		JPanel panel2 = multiOutputPanel(attrMapPerOutput, numOutputs, outputNameMap);
		panel.setMinimumSize(panel2.getSize());
		panel.add(panel2);
		panel.repaint();
		panel.revalidate();
	}

	private static JPanel multiOutputPanel(Map<String, Map<String, Map<String, Double>>> attrMapPerOutput,
			int numOutputs, Map<String, String> outputNameMap) {
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout((attrMapPerOutput.size() / 2) + 1, 2));
		for (String attr : attrMapPerOutput.keySet()) {
			final JFreeChart chart = ChartFactory.createMultiplePieChart(attr, // chart title
					createMultiOutputDataset(attrMapPerOutput.get(attr), numOutputs, outputNameMap), // dataset
					TableOrder.BY_ROW, true, // include legend
					true, false);

			panel.add(new ChartPanel(chart));
		}
		return panel;
	}

	private static CategoryDataset createMultiOutputDataset(Map<String, Map<String, Double>> attrMapOutputs,
			int numOutputs, Map<String, String> outputNameMap) {
		int totalAttrVals = 0;
		for (String key : attrMapOutputs.keySet())
			totalAttrVals = attrMapOutputs.get(key).size();
		double[][] matData = new double[numOutputs][totalAttrVals];
		int attrValIndex = 0;
		ArrayList<String> cols = new ArrayList<String>();
		ArrayList<String> rows = new ArrayList<String>();
		final DefaultCategoryDataset dataset = new DefaultCategoryDataset();

		for (String outputkey : attrMapOutputs.keySet()) {
			for (String str : attrMapOutputs.get(outputkey).keySet()) {
				dataset.addValue(attrMapOutputs.get(outputkey).get(str), outputNameMap.get(outputkey), str);
			}
		}
		return dataset;
	}
}